<template>
  <div  class="card-and-choices h-100 d-flex flex-column"
        :style="style"
        :shown="shown">
    <div class="top-part on-top d-flex justify-content-between">
      <div class="invisibilable"
          :visible="currentCard.left">
        <side-choice  :text="currentCard.left"
                      side="left"
                      :currentSide="currentSide"/>
      </div>

      <div class="invisibilable"
          :visible="currentCard.right">
        <side-choice  :text="currentCard.right"
                      side="right"
                      :currentSide="currentSide"/>
      </div>
    </div>

    <div class="my-2 flex-grow-1 on-bottom">
      <card :message="currentCard.card"
            :button="currentCard.button"
            @onSide="onSide"
            @choose="choose"
            :card="currentCard"/>
    </div>

    <div class="d-flex justify-content-center on-top invisibilable"
        :visible="currentCard.bottom">
      <side-choice  :text="currentCard.bottom"
                    side="bottom"
                    :currentSide="currentSide"/>
    </div>
  </div>
</template>

<script>
import Card from '@/components/cards/Card'
import SideChoice from '@/components/cards/SideChoice'

export default {
  name: 'card-and-choices',
  components: { Card, SideChoice },
  props: ['currentCard'],
  data () {
    return {
      currentSide: null,
      movement: { x: 0, y: 0 },
      shown: false
    }
  },
  computed: {
    style () {
      return {
        transform: `translate(${this.movement.x}, ${this.movement.y})`
      }
    }
  },
  methods: {
    onSide (side) {
      this.currentSide = side
    },
    choose () {
      if (this.currentSide === 'right') {
        this.movement = { x: '100vw', y: '0' }
      } else if (this.currentSide === 'left') {
        this.movement = { x: '-100vw', y: '0' }
      } else if (this.currentSide === 'bottom') {
        this.movement = { x: 0, y: '100vh' }
      } else {
        this.movement = { x: 0, y: 0 }
      }

      if (this.currentSide) {
        setTimeout(() => {
          this.$emit('goNext')
        }, 400)
      }
    }
  },
  mounted () {
    this.$nextTick(() => { this.shown = true })
  }
}
</script>

<style scoped lang="scss">
.on-top {
  z-index: 10;
}

.on-bottom {
  z-index: 0;
}

.invisibilable {
  opacity: 0;

  &[visible] {
    opacity: 1;
  }
}

.card-and-choices {
  transition: transform 200ms ease-in-out, opacity 500ms ease-in-out;
  opacity: 0;

  &[shown] {
    opacity: 1;
  }
}

</style>
